<template>
    <div class="app-container">
      <el-row :gutter="20">
        <!--用户数据-->
        <el-col :span="24" :xs="24">
            <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
                <el-form-item label="实体卡名称" prop="cardName">
                    <el-input
                    v-model="queryParams.cardName"
                    placeholder="请输入实体卡名称"
                    clearable
                    style="width: 240px"
                    @keyup.enter.native="handleQuery"
                    />
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                    <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
                </el-form-item>
            </el-form>
          <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
              <el-button
                type="primary"
                plain
                icon="el-icon-plus"
                size="mini"
                @click="handleAdd"
                v-hasPermi="configPermi.add"
              >添加新卡</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
          </el-row>
  
          <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
            <el-table-column type="index" label="序号" align="center"  />
            <el-table-column label="实体卡名称" align="center" key="cardName" prop="cardName" v-if="columns[0].visible" :show-overflow-tooltip="true" />
            <el-table-column label="实体卡价格" align="center" key="price" prop="price" v-if="columns[1].visible" :show-overflow-tooltip="true" />
            <el-table-column label="使用期限" align="center" key="useType" prop="useType" v-if="columns[2].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ setUseType(scope.row) }}</span>
                </template>
            </el-table-column>
            <el-table-column label="生效日期" align="center" key="name3" prop="name3" v-if="columns[3].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ setEffectiveDateType(scope.row) }}</span>
                </template>
            </el-table-column>
            <el-table-column label="支持储值" align="center" key="name4" prop="name4" v-if="columns[4].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ setIsStorageValue(scope.row) }}</span>
                </template>
            </el-table-column>
            <el-table-column label="支持积分" align="center" key="name5" prop="name5" v-if="columns[5].visible" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ setIsCredit(scope.row) }}</span>
                </template>
            </el-table-column>
            <el-table-column label="创捷时间" align="center" key="createTime" prop="createTime" v-if="columns[6].visible" :show-overflow-tooltip="true" />
            <el-table-column
              label="操作"
              align="center"
              class-name="small-padding fixed-width"
            >
              <template slot-scope="scope" >
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-edit"
                  @click="handleDetails(scope.row)"
                  v-hasPermi="configPermi.details"
                >详情</el-button>
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-edit"
                  @click="handleUpdate(scope.row)"
                  v-hasPermi="configPermi.edit"
                >编辑</el-button>
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.row)"
                  v-hasPermi="configPermi.delect"
                >删除</el-button>
              </template>
            </el-table-column>
          </el-table>
  
          <pagination
            v-show="total>0"
            :total="total"
            :page.sync="queryParams.pageNum"
            :limit.sync="queryParams.pageSize"
            @pagination="getList"
          />
        </el-col>
      </el-row>
      <!--  新增或修改  -->
      <addAndEdit ref="addAndEdit" @refresh="getList" />
      <detailsBox ref="detailsBox"></detailsBox>
    </div>
  </template>
  
  <script>
  import { 
    listTableApi, 
    delTableParamsApi
    } from "@/api/CURD";
  import addAndEdit from "./formBox/physicalCardAllocationForm.vue"
  import detailsBox from "./detailsBox/physicalCardAllocationDetails.vue"
  export default {
    name: "User",
    dicts: [],
    components: {addAndEdit,detailsBox},
    data() {
      return {
        title: "实体卡配置",// 通用标题
        configPermi: {
          add: ['physicalCard:physicalCardAllocation:add'], // 新增权限
          details: ['physicalCard:physicalCardAllocation:details'], // 详情权限
          delect: ['physicalCard:physicalCardAllocation:delect'], // 删除权限
          edit: ['physicalCard:physicalCardAllocation:edit'], // 编辑权限
          upload: [''],// 导入权限
          export: [''],// 导出权限
          release: ['']
        },
        configUrl: {
          list: '/merchant/merchantEntitycardConfig/pageList', // 列表地址
          delect: '/merchant/merchantEntitycardConfig/deleteById', // 删除地址
          upload: '',// 导入地址
          download:'', // 下载模板地址
          export: '',// 导出地址
          updateStatusById: '',
        },
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 用户表格数据
        tableList: null,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
        },
        dateRange: [],
        // 控制列表是否显示
        columns: [
          { key: 0, label: `实体卡名称`, visible: true },
          { key: 2, label: `实体卡价格`, visible: true },
          { key: 3, label: `使用期限`, visible: true },
          { key: 4, label: `生效日期`, visible: true },
          { key: 5, label: `支持储值`, visible: true },
          { key: 6, label: `支持积分`, visible: true },
          { key: 7, label: `创捷时间`, visible: true },
        ],
      };
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询用户列表 */
      getList() {
        this.loading = true;
        listTableApi(
          this.configUrl.list,
          this.addDateRange(
            this.queryParams, 
            this.dateRange)).then(response => {
              this.tableList = response.data.rows;
              this.total = response.data.total;
              this.loading = false;
          }
        ).catch (error=>{
          console.error('获取列表失败!!!!',error)
          this.tableList = [];
          this.total = 0;
          this.loading = false
        }) 
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.queryParams = {
          pageNum: 1,
          pageSize: 10,
        }
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id);
        this.single = selection.length != 1;
        this.multiple = !selection.length;
      },
      /** 新增按钮操作 */
      handleAdd() {
        if(this.$refs.addAndEdit) {
          this.$refs.addAndEdit.initData(this.title + '新增', "ADD",{})
        }
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        if(this.$refs.addAndEdit) {
          this.$refs.addAndEdit.initData(this.title + '基本信息编辑', "EDITInit",{...row})
        }
      },
      handleUpdate(row) {
        if(this.$refs.addAndEdit) {
          this.$refs.addAndEdit.initData(this.title + '规格信息编辑', "EDITInit",{...row})
        }
      },
      handleDetails(row){
        if(this.$refs.detailsBox) {
          this.$refs.detailsBox.initData(this.title + '详情',"DEATILSInit", row)
        }
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$modal.confirm('是否确认删除数据项？').then( () => {
          return delTableParamsApi(this.configUrl.delect,{
            id: ids
          });
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch((e) => {
          console.error("删除失败====",e)
        });
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download(this.configUrl.export, {
          ...this.queryParams
        }, `${this.title }_${new Date().getTime()}.xlsx`)
      },
      /** 导入按钮操作 */
      handleImport() {
        if(this.$refs.upload) {
          this.$refs.upload.initData({
            width: '400px',
            // 弹出层标题（用户导入）
            title: this.title + "导入",
            // 下载模板地址
            importTemplate: this.configUrl.download,
            // 上传的地址
            url: this.configUrl.upload
          })
        }
      },
      /**
       * 修改状态
       * @date 2023-11-22
       * @returns {any}
       */
      openAttraction(row) {
        this.$modal.confirm(`是否确认${row.status == 1 ? '上架' : '下架'} ${row.name}点位吗？`).then( () => {
          return listTableApi(this.configUrl.updateStatusById,{
            id: row.performId,
            status: row.status == 1 ? 0 : 1
          });
        }).then(() => {
          this.getList()
          this.$modal.msgSuccess(`${row.status == 1 ? '上架' : '下架'}成功`);
        }).catch((e) => {
          console.error("失败====",e)
        });
      },
      /** 设置使用期限  */
      setUseType(row){
        if(row.useType == 1) {
          return '永久生效'
        }else if(row.useType == 2) {
          return '' + row.useDay + '天有效'
        }else if(row.useType == 3) {
          return '' + row.useEndDay + '内有效'
        }else{
          return '--'
        }
      },
      // 生效日期
      setEffectiveDateType(row){
        if(row.useType == 1) {
          return '制卡之日生效'
        }else if(row.useType == 2) {
          return '激活之日生效'
        }else{
          return '--'
        }
      },
      // 支持储值
      setIsStorageValue(row){
        if(row.isStorageValue == 0) {
          return '不可储值'
        }else if(row.isStorageValue == 1) {
          return row.storageMaxAmount ? ('最大储值'+row.storageMaxAmount):'可储值'
        }else{
          return '--'
        }
      },
      // 支持积分
      setIsCredit(row){
        if(row.isCredit == 0) {
          return '不可积分'
        }else if(row.isCredit == 1) {
          return '可积分'
        }else{
          return '--'
        }
      },
    }
  };
  </script>
  